﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.display.*;
	import flash.geom.*;
	import flash.events.*;
	import flash.filters.*;
	
	public class Bullet extends BitmapSprite {
		private var dx:Number,dy:Number;
		private var lastTime:uint;
		public var dead:Boolean=false;
		public var evil:Boolean;
		public function Bullet(mode:Mode,evil:Boolean){
			if(evil){
				surf=new Bitmap(new bullete2(6,8));
				dy=1/6;
			}else{
				surf=new Bitmap(new bullet(6,8));
				dy=-1/4;
			}
			surf.width=6;
			surf.height=8;
			dx=0;
			this.evil=evil;
			addChild(surf);
			buildHitRect();
			lastTime=Time.get();
			mode.addLocalEventListener(this,Event.ENTER_FRAME, onNextFrame);
		}
		private function onNextFrame(ev:Event){
			var now:uint=Time.get();
			var diff:uint=now-lastTime;
			lastTime=now;
			x+=dx*diff;
			y+=dy*diff;
			if(y<0){
				dead=true;
			}
		}
	}
}