﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.events.*;
	public class CheatManager {
		private var lastInput:Array=[];
		private var game:Game;
		private static const MAX_CHEAT_LENGTH=14;
		private static const UP=38;
		private static const DOWN=40;
		private static const LEFT=37;
		private static const RIGHT=39;
		private static const CHEAT_KONAMI=[UP,UP,DOWN,DOWN,LEFT,RIGHT,LEFT,RIGHT,
										   ord("B"),ord("A")];
		private static const CHEAT_SUPERAMMO=[UP,DOWN,LEFT,RIGHT,UP,DOWN,LEFT,RIGHT];
		private static const CHEAT_ALLDIVE=[ord("G"),ord("O"),ord("G"),ord("O"),ord("G"),ord("O")];
		private static const CHEAT_DIE=[ord("D"),ord("I"),ord("E")];
		private static const CHEAT_TREE=[ord("G"),ord("E"),ord("T"),ord("T"),ord("R"),ord("E"),ord("E")];
		private static const CHEAT_TREE2=[ord("G"),ord("O"),ord("T"),ord("T"),ord("R"),ord("E"),ord("E")];
		private static const CHEAT_WIN=[ord("W"),ord("I"),ord("N"),ord("M"),ord("A"),ord("T"),ord("E")];
		public function CheatManager(game:Game){
			this.game=game;
		}
		private static function ord(s:String):uint{
			return s.toUpperCase().charCodeAt(0);
		}
		public function addInput(key:KeyboardEvent):void{
			lastInput.unshift(key.keyCode);
			while(lastInput.length>MAX_CHEAT_LENGTH){
				lastInput.pop();
			}
			checkForCheat();
		}
		private function checkAgainst(cheat:Array,justcheck:Boolean=false):Boolean{
			if(cheat.length>lastInput.length)return false; 
			for(var i=0;i<cheat.length;i++){
				if(cheat[i]!=lastInput[(cheat.length-1)-i]){
					return false;
				}
			}
			if(!justcheck){
				postCheat();

			}
			return true;
		}
		private function checkForCheat():void{
			//dumpBuffer();
			if(checkAgainst(CHEAT_KONAMI)){
				game.player.godmode=!game.player.godmode;
				game.addMessage("KONAMI TIME FOREVER GO !!!!");
			}
			if(checkAgainst(CHEAT_SUPERAMMO)){
				game.player.autoShoot();
				game.addMessage("YOUR SHOOT ALWAYS !!!!");
			}
			if(checkAgainst(CHEAT_ALLDIVE)){
				game.diver.initDive(true);
				game.addMessage("! OH NO !");
			}
			if(checkAgainst(CHEAT_DIE)){
				game.player.godmode=false;
				game.killPlayer();
				game.addMessage("BYE");
			}
			if(checkAgainst(CHEAT_TREE,true) || checkAgainst(CHEAT_TREE2,true)){
				game.addMessage("HIGHER SCORE !!!");
				GameData.gotTree=true;
				lastInput=[];
			}
			if(checkAgainst(CHEAT_WIN)){
				game.addMessage("YOU PUNK !!");
				game.startWin();
			}
		}
		private function postCheat():void{
			lastInput=[];
			GameData.cheated=true;
		}
		private function strForKey(k:uint):String{
			switch(k){
				case UP:
					return "▲";
				case DOWN:
					return "▼";
				case LEFT:
					return "◄";
				case RIGHT:
					return "►";
				default:
					if(k>64 && k<91){
						return String.fromCharCode(k);
					}else{
						return String(k);
					}
					
			}
			
		}
		public function dumpBuffer():void{
			var s:String="CHEAT[";
			for(var i=lastInput.length-1;i>=0;i--){
				s+=strForKey(lastInput[i]);
				if(i!=0){
					s+=",";
				}
			}
			s+="]";
			trace(s);
		}
	}
}