﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	public class ColorSys{
		static function hexifyArray(rgb:Array):uint{
			return hexify(rgb[0],rgb[1],rgb[2]);
		}
		static function hexify(r:uint,g:uint,b:uint):uint{
			return (r&0xFF)<<16|(g&0xFF)<<8|(b&0xFF);
		}
		// From http://www.easyrgb.com/math.php?MATH=M21#text21
		static function HSV2RGB(H:Number,S:Number,V:Number):Array{
			var var_r:Number,var_g:Number,var_b:Number;
			if ( S == 0 ){                       //HSV values = 0 ÷ 1
			return [int(V*255),int(V*255),int(V*255)];
			}else{
			   var var_h:Number = H * 6;
			   if ( var_h == 6 ) var_h = 0;      //H must be < 1
			   var var_i:Number = int( var_h );             //Or ... var_i = floor( var_h )
			   var var_1:Number = V * ( 1 - S );
			   var var_2:Number = V * ( 1 - S * ( var_h - var_i ) );
			   var var_3:Number = V * ( 1 - S * ( 1 - ( var_h - var_i ) ) );
			
			   if      ( var_i == 0 ) { var_r = V     ; var_g = var_3 ; var_b = var_1; }
			   else if ( var_i == 1 ) { var_r = var_2 ; var_g = V     ; var_b = var_1; }
			   else if ( var_i == 2 ) { var_r = var_1 ; var_g = V     ; var_b = var_3; }
			   else if ( var_i == 3 ) { var_r = var_1 ; var_g = var_2 ; var_b = V;     }
			   else if ( var_i == 4 ) { var_r = var_3 ; var_g = var_1 ; var_b = V;    }
			   else                   { var_r = V     ; var_g = var_1 ; var_b = var_2; }
			
			   return [int(var_r * 255),int(var_g * 255),int(var_b * 255)];
			}
		}
	}
}