﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.utils.*;
	import flash.events.*;
	public class DiveManager{
		private var enemies:Array;
		private var lastdive:int;
		private static const DIVE_DELAY:int=500;
		private var game:Game;

		public function DiveManager(game:Game,enemylist:Array){
			this.game=game;
			this.enemies=enemylist;
			game.simpleSchedule(2000,diveTimer,0);
			game.simpleSchedule(400,checkShoot,0);
		}
		public function onDive():Boolean{
			for(var i=0;i<enemies.length;i++){
				if(enemies[i].onDive()){
					return true;
				}
			}
			return false;
		}
		private function diveTimer(ev:Event=null):void{
			checkDive();
		}
		private function checkShoot(ev:Event=null):void{
			for(var i=0;i<enemies.length;i++){
				if(enemies[i].onDive() && !enemies[i].diveEnded() &&!enemies[i].returning){
					var dir:Number=((720+enemies[i].rotation)%360);
					//trace(dir);
					if(Math.abs(dir-180)<40 && Math.random()<GameData.shootChance){
						game.createEnemyBullet(enemies[i].x,enemies[i].y);
					}
				}
			}
		}
		public function checkDive():Boolean{
			var diving:Boolean=false;
			if(enemies.length==0)return false; //No enemies? no dives!
			for(var i=0;i<enemies.length;i++){
				if(enemies[i].onDive()){
					diving=true;
					if(enemies[i].diveEnded()){
						//trace("DIVE ALL OVER"+enemies[i].returning);
						if(enemies[i].returning){
							//enemies[i].startIdle();
							continue;
						}
						returnDive(enemies[i]);
					}
				}
			}
			if(diving){
				return false; //We're already diving so no need to dive again
			}
			if(Time.get()-lastdive<DIVE_DELAY){
				return false;
			}
			initDive();
			return true;
		}
		public function returnDive(e:Enemy):void{
			var path:DivePath=new DivePath(DivePathData.return1);
			e.x=e.savedPos.x;
			e.y=e.savedPos.y;
			path.looping=false;
			e.enterPath(path,false);
			path.speed=1.0;
			path.setRelativeOffset(1.0);
			path.setRelativeOffset(0.0);
			path.setPos(e);
			e.returning=true;
		}
		public function initDive(all:Boolean=false):void{
			var hmany:int=int(Math.random()*3+1);
			var which:int=int(Math.random()*(enemies.length-hmany+1));
			var path:int=int(Math.random()*(DivePathData.pathlist.length-1));
			if(all){
				hmany=enemies.length;
				which=0;
			}
			var lrow:uint=enemies[which].row;
			for(var i=0;i<hmany && i<enemies.length;i++){
				var e:Enemy=enemies[which+i];
				if(e.onDive()||e.returning)continue;
				if(!all && e.row!=lrow)continue;
				if(all){
					path=int(Math.random()*(DivePathData.pathlist.length-1));
				}
				e.enterPath(new DivePath(DivePathData.pathlist[path]),false);
				lrow=e.row;
			}
			lastdive=Time.get();
		}
	}
}