﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package{
	import flash.display.Sprite;
	public class DivePath{
		private var path:Array;
		public var looping:Boolean;
		public var startx:Number,starty:Number;
		private var mult:Number=1.0;
		private var offset:int;
		private var pos:Number;
		public var speed:Number;
		public var ended:Boolean=false;
		public function DivePath(path:Array){
			this.path=path;
			this.mult=4.4;
			this.looping=false;
			offset=0;
			pos=0.0;
			speed=1.0;
			ended=false;
		}
		public function setInitPos(s:Sprite):void{
			startx=s.x;
			starty=s.y;
			pos=0.0;
		}
		public function randomizeOffset():void{
			setRelativeOffset(Math.random());
		}
		public function getRelativeOffset():Number{
			var ipos:int=pos+this.offset;
			if(ipos>=path.length){ // dive over
				if(this.looping){
					ipos=ipos%this.path.length;
				}else{
					ipos=this.path.length-1;
				}
			}
			return (ipos)/Number(this.path.length-1);
		}
		public function setRelativeOffset(v:Number):void{
			offset=int(v*(this.path.length-1));
			startx+=(path[offset][1]*mult);
			starty-=(path[offset][2]*mult);
		}
		public function update(diff:uint):void{
			pos+=speed*diff/30.0;
		}
		public function setPos(s:Sprite):void{
			var ipos:int=pos+this.offset;
			if(ipos>=path.length){ // dive over
				if(this.looping){
					ipos=ipos%this.path.length;
				}else{
					ipos=this.path.length-1;
					ended=true;
				}
			}
			s.rotation=path[ipos][0];
			s.x=startx-(path[ipos][1]*mult);
			s.y=starty+(path[ipos][2]*mult);
		}
	}
}