﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.display.*;
	public class Explosion extends Sprite {
		private var surfs:Array;
		private var progress:int;
		private var lastupdate:int;
		private var dead:Boolean=false;
		private static const UPDATE_SPEED:int=100;
		public function Explosion(x:int,y:int,precreate:int=0){
			surfs=[];
			this.x=x-32;
			this.y=y-32;
			this
			addBitmap(boom1,64,64);
			addBitmap(boom2,64,64);
			addBitmap(boom3,64,64);
			addBitmap(boom4,64,64);
			addBitmap(boom5,64,64);
			progress=0;
			//addChild(surfs[progress]);
			lastupdate=Time.get()+precreate-UPDATE_SPEED;
			update();
		}
		public function setRotation(r:int):void{
			
		}
		public function limit(frames:uint):void{
			if(frames<this.surfs.length){
				this.surfs.splice(frames,this.surfs.length);
			}
		}
		private function addBitmap(bclass:Class,w:int,h:int):void{
			var surf:Bitmap=new Bitmap(new bclass(w,h));
			surf.width=w;
			surf.height=h;
			surfs.push(surf);
		}
		public function update():void{
			if(dead)return;
			var now:int=Time.get();
			if(now-lastupdate>=UPDATE_SPEED){
				if(progress>0){
					removeChild(surfs[progress-1]);
				}
				if(progress+1>surfs.length){
					dead=true;
					return;
				}
				addChild(surfs[progress]);
				progress+=1;
				lastupdate=now;
			}
		}
	}
}