﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	public class LevelManager{
		private var game:Game;
		private var levels:Array=[Level1,Level2,Level3];
		public function LevelManager(game:Game){
			this.game=game;
		}
		public function initLevel(level:uint):Array{
			var out:Array=[]
			if(level-1>=levels.length){
				game.winGame();
				return [];
			}
			levels[level-1].init(out,game);
			return out;
		}
		public function nextLast(level:uint):Boolean{
			return level>=levels.length;
		}
	}
}
class OrderlyLinesLevel{
	public static function init(out:Array,game:Game,rows:uint,perRow:uint){
		for(var r:uint=0;r<rows;r++){
			for(var i:uint=0;i<perRow;i++){
				var e:Enemy = new Enemy(game,r%Enemy.ENEMY_TYPES,r);
				e.setPos(50+((10-perRow)/2+i)*50,50+r*50);
				out.push(e);
			}
		}
	}
}
class Level1 {
	public static function init(out:Array,game:Game):void{
		OrderlyLinesLevel.init(out,game,2,8);
		GameData.shootChance=0.4;
	}
}
class Level2 {
	public static function init(out:Array,game:Game):void{
		OrderlyLinesLevel.init(out,game,4,10);
		GameData.shootChance=0.6;
	}
}
class Level3 {
	public static function init(out:Array,game:Game):void{
		OrderlyLinesLevel.init(out,game,7,10);
		GameData.shootChance=0.9;
	}
}