﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.display.*;
	import flash.geom.*;
	import flash.events.*;
	import flash.text.*;


	public class MainMenu extends TextPage {
		public static const COPYRIGHTVERSION="(C) 1982-2007 BOBA VIDEOGAMINGS v3.L";
		public function MainMenu(switcher:ModeSwitcher,stage:Stage){
			super(switcher,stage);
			createTitle(stage);
			var menuItems:Array=["FRESH GAME","INSTRUCTORS/TALE","CREDIT","QUIT GAMER"];
			var tf:TextField;
			for(var i:int=0;i<menuItems.length;i++){
				tf=simpleText(stage,menuItems[i],stage.stageWidth/2-120,stage.stageHeight/2+50+i*30);
				addLocalEventListener(tf,MouseEvent.MOUSE_UP,clickedButton);
			}
			tf=simpleText(stage,COPYRIGHTVERSION,0,stage.stageHeight-25);
			addLocalEventListener(tf,MouseEvent.MOUSE_UP,clickedButton);
			addLocalEventListener(stage,KeyboardEvent.KEY_UP,hitKey);
		}
		private function clickedButton(me:MouseEvent){
			if(me.target){
				me.stopImmediatePropagation();
				switch(me.target.text){
					case "CREDIT":
						return this.switcher.simpleMode(Mode.MODE_CREDITS);
					case "INSTRUCTORS/TALE":
						return this.switcher.simpleMode(Mode.MODE_HELP);
					case "FRESH GAME":
						return this.switcher.simpleMode(Mode.MODE_START);
					case "WIN":
						return this.switcher.simpleMode(Mode.MODE_WIN);
					case "QUIT GAMER":
						quit();
					case COPYRIGHTVERSION:
						if(me.stageX<37){
							return this.switcher.simpleMode(Mode.MODE_CHEATS);
						}
				}
			}
			//trace(me.target.text);
			
		}
		private function createTitle(stage:Stage){
			var bformat=new TextFormat();
			bformat.font="Arial";
			bformat.color=0xFFFFFF;
			bformat.size=72;
			var tf:TextField=new TextField();
			tf.x=40;
			tf.y=30;
			tf.wordWrap=true;
			tf.text=" サーデイビデ\nビーデイブルウ";
			tf.autoSize=TextFieldAutoSize.CENTER;
			tf.textColor=0xFFFFFF;
			tf.embedFonts=false;
			tf.width=stage.stageWidth;
			tf.selectable=false;
			tf.defaultTextFormat=bformat;
			tf.setTextFormat(bformat);
			this.addChild(tf);
			var tf2:TextField=simpleText(stage,"REMOTE ETHER ARACHNID WARTIME",40,200);
			
			
	
		}
		private function hitKey(ev:KeyboardEvent):void{
			if(ev.keyCode==27){ // ESCAPE
				quit();
			}
		}
	}
}