﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.display.*;
	import flash.geom.*;
	import flash.events.*;
	
	public class ModeSwitcher extends Sprite {
		private var current:Mode=null;
		public function ModeSwitcher(){
			stage.scaleMode=StageScaleMode.NO_SCALE;
			GameData.reset();
			simpleMode(Mode.MODE_MENU)
		}
		public function simpleMode(newmode:int){
			endCurrentMode();
			switch(newmode){
				case Mode.MODE_CREDITS:
					return switchMode(new CreditsPage(this,stage));
				case Mode.MODE_MENU:
					return switchMode(new MainMenu(this,stage));
				case Mode.MODE_HELP:
					return switchMode(new InstructionsPage(this,stage));
				case Mode.MODE_GAME:
					return switchMode(new Game(this,stage));
				case Mode.MODE_GAMEOVER:
					return switchMode(new GameOverPage(this,stage));
				case Mode.MODE_WIN:
					return switchMode(new YouWinPage(this,stage));
				case Mode.MODE_STATS:
					return switchMode(new StatsPage(this,stage));
				case Mode.MODE_CHEATS:
					return switchMode(new CheatsPage(this,stage));
				case Mode.MODE_START:
					return switchMode(new GameStartPage(this,stage));
			}
		}
		public function endCurrentMode():void{
			if(current!=null){
				current.exitMode();
				removeChild(current);
				current=null;
			}
		}
		public function switchMode(newmode:Mode):void{
			current=newmode;
			current.enterMode();
			addChild(newmode);
		}
	}
}