﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.display.*;
	import flash.geom.*;
	import flash.events.*;
	import flash.filters.*;
	
	public class Player extends Sprite {
		private var surf:Bitmap;
		public var bullets:Array;
		public var maxBullets=3;
		private static const POOF_TIME=100;
		public var dead:Boolean=false;
		private var flyingOff:Boolean=false;
		private var startTime:uint;
		private var startY:Number;
		private var lastPoof:uint;
		private var game:Game;
		public var godmode:Boolean=false;
		public function Player(mode:Game,stage:Stage){
			surf=new Bitmap(new alien13(28,22));
			surf.width=28;
			surf.x=-14;
			surf.height=22;
			surf.y=-11;
			addChild(surf);
			x=stage.stageWidth/2-surf.width/2;
			y=stage.stageHeight-surf.height;
			this.game=mode;
			bullets=[];
			
			mode.addLocalEventListener(stage,MouseEvent.MOUSE_MOVE,mouseMove);
			mode.addLocalEventListener(stage,MouseEvent.MOUSE_DOWN,mouseButton);
		}
		public function flyOff():void{
			if(flyingOff)return;
			flyingOff=true;
			dead=true;
			startTime=Time.get();
			startY=y;
			lastPoof=startTime;
			this.game.addLocalEventListener(this,Event.ENTER_FRAME,everyFrame);
			this.game.stars.speed=1/1.5;
		}
		private function everyFrame(ev:Event){
			var now:uint=Time.get();
			var diff:uint=now-startTime;
			this.y=startY-diff/5.0;
			if(now-lastPoof>POOF_TIME){
				this.game.addExplosion(x,y+surf.height).limit(2);
				lastPoof=now;
			}
		}
		public function mouseMove(ev:MouseEvent){
			if(!dead)x=ev.stageX;
		}
		public function mouseButton(ev:MouseEvent){
			if(!dead)fireBullet();
		}
		public function autoShoot():void{
			maxBullets=25;
			game.simpleSchedule(200,fireBullet,0);
		}
		private function fireBullet(ev:Event=null){
			if(dead)return;
			for(var i=0;i<bullets.length;i++){
				if(bullets[i].dead){
					parent.removeChild(bullets[i]);
					bullets.splice(i,1);
					i--;
				}
			}
			if(bullets.length>=maxBullets){
				return;
			}
			var b:Bullet = new Bullet(game,false);
			b.x=x-3;
			b.y=y-3;
			bullets.push(b);
			parent.addChild(b);
			GameData.shotCount++;
		}
	}
}