﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.display.*;
	import flash.geom.*;
	import flash.events.*;
	public class Starfield extends Sprite {
		private var lastUpdate:uint;
		private var stageHeight:Number;
		private var top:Shape;
		private var bottom:Shape;
		public var speed:Number=1/4.0;
		public function Starfield(stage:Stage){
			lastUpdate=Time.get();
			stageHeight=stage.stageHeight;
			top=new Shape();
			bottom=new Shape();
			addStars(top,stage);
			addStars(bottom,stage);
			top.y=0;
			bottom.y=stageHeight;
			addChild(top);
			addChild(bottom);
		}
		private function addStars(s:Shape,stage:Stage):void{
			//s.graphics.beginFill(0xFFFFFF);
			for(var i=0;i<100;i++){
				var color:Array=ColorSys.HSV2RGB(Math.random(),0.2, 0.98);
				s.graphics.beginFill(ColorSys.hexifyArray(color));
				s.graphics.drawRect(Math.random()*stage.stageWidth,Math.random()*stage.stageHeight,2,3);
				s.graphics.endFill();
			}
			
		}
		public function update():void{
			var now:uint=Time.get();
			var diff:Number=(now-lastUpdate)*speed;
			
			top.y+=diff;
			bottom.y+=diff;
			if(bottom.y>stageHeight){
				bottom.y=top.y-stageHeight;
				var swap:Shape=bottom;
				bottom=top;
				top=swap;
			}
			lastUpdate=now;
		}
	}
}