﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.display.*;
	import flash.geom.*;
	import flash.events.*;
	import flash.text.*;

	public class StatsPage extends TimedPage {
		private var lineFinal:String="";
		public function StatsPage(switcher:ModeSwitcher,stage:Stage){
			super(switcher,stage,20000,Mode.MODE_MENU);
			if(GameData.nextLevel &&!GameData.wonGame){
				this.pageDestination=Mode.MODE_GAME;
			}
			blankBG(stage);
			var message:String="ENDS STATISTIC";
			if(GameData.nextLevel){
				message="STAGE ALL DONE";
				GameData.currentLevel++;
			}
			if(GameData.wonGame){
				message="EVERY STAGE IS CLEAR !!";
			}
			var tf:TextField=simpleText(stage,message,0,0);
			tf.autoSize=TextFieldAutoSize.CENTER;
			addChild(tf);
			if(GameData.cheated){
				lineFinal=" (CHEATER)";
			}
			var menuItems:Array=["",
								 "<FINAL TIME",formatTime(),"","<HIT RATIO"];
			formatHits(menuItems);
			menuItems.push("","<DESTROY RATIO");
			formatKills(menuItems);
			renderTextList(stage,0,10,menuItems);
		}
		private function formatTime():String{
			var secs:uint=(GameData.endTime-GameData.startTime)/1000;
			if(secs<60){
				return secs+" second" + (secs==1?"":"s")+lineFinal;
			}else{
				var mins:uint=uint(secs/60);
				secs=secs%60;
				return mins+" minute" +(mins==1?" ":"s ") + secs + " second" + (secs==1?"":"s")+lineFinal;
			}
		}
		private function formatHits(out:Array):void{
			out.push("SHOOTS:       "+GameData.shotCount+lineFinal);
			out.push("HITS:           "+GameData.hitCount+lineFinal);
			var percent:uint=(100.0*GameData.hitCount/GameData.shotCount);
			out.push("ACCURACY:   %"+percent+lineFinal);
		}
		private function formatKills(out:Array):void{
			if(GameData.wonLevel){
				out.push("ALL ENEMY ARE DESTROY"+lineFinal);
				if(!GameData.wonGame){
					out.push("","PRESS CLICK FOR NEXT STAGE");
				}
				return;
			}
			out.push("ENEMY:                "+GameData.enemyCount+lineFinal);
			out.push("DESTROYS:           "+GameData.enemyDead+lineFinal);
			var percent:uint=(100.0*GameData.enemyDead/GameData.enemyCount);
			out.push("COMPLETITY:       %"+percent+lineFinal);
		}
	}
}