﻿/*  Copyright 2007 Philip D. Bober
    REMOTE ETHER ARACHNID WARTIME is distributed under the terms of the GNU General Public License.

    This file is part of REMOTE ETHER ARACHNID WARTIME.

    REMOTE ETHER ARACHNID WARTIME is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    REMOTE ETHER ARACHNID WARTIME is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with REMOTE ETHER ARACHNID WARTIME.  If not, see <http://www.gnu.org/licenses/>.
*/
package {
	import flash.display.*;
	import flash.geom.*;
	import flash.events.*;
	import flash.text.*;

	public class TextPage extends Mode {
		protected var format:TextFormat;
		public function TextPage(switcher:ModeSwitcher,stage:Stage){
			super(switcher);
			
			createFormat();
		}
		protected function renderTextList(stage:Stage,x:int,y:int,menuItems:Array){
			for(var i:int=0;i<menuItems.length;i++){
				var off:int=x+60,str:String=menuItems[i],japan:Boolean=false;
				while(str.charAt(0)=='<'){
					off-=60;
					str=str.substr(1);
				}
				if(str.charAt(0)=='!'){
					str=str.substr(1);
					japan=true;
				}
				var tf:TextField=simpleText(stage,str,off,y+i*30);
				if(japan){
					tf.embedFonts=false;
				}
			}
		}
		protected function blankBG(stage:Stage){
			var sh:Shape=new Shape();
			sh.graphics.beginFill(0x000000);
			sh.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
			addChild(sh);
		}
		protected function simpleText(stage:Stage,str:String,x:int,y:int):TextField{
			var tf:TextField=makeSimpleText(stage,str,x,y,format);
			this.addChild(tf);
			return tf;
		}
		public static function makeSimpleText(stage:Stage,
											  str:String,x:int,y:int,mformat:TextFormat=null):TextField{
			if(mformat==null){
				mformat=makeFormat();
			}
			var tf:TextField=new TextField();
			tf.x=x;
			tf.y=y;
			tf.height=28;
			tf.autoSize=TextFieldAutoSize.LEFT;
			tf.text=str;
			tf.textColor=0xFFFFFF;
			tf.embedFonts=true;
			tf.width=stage.stageWidth;
			tf.selectable=false;
			tf.defaultTextFormat=mformat;
			tf.setTextFormat(mformat);
			return tf;
		}
		public static function makeFormat():TextFormat{
			var mformat:TextFormat=new TextFormat();
			mformat.font="Joystix_23pt_st";
			mformat.color=0xFFFFFF;
			mformat.size=23;
//			dumpFonts();
			return mformat;
		}
		public static function dumpFonts():void{
			var arr:Array=Font.enumerateFonts(false);
			for(var i=0;i<arr.length;i++){
				trace(arr[i].fontName);
			}
		}
		protected function createFormat():TextFormat{
			format=makeFormat();
			return format;
		}
		
		protected function fontify(tf:TextField){
			tf.defaultTextFormat=format;
			tf.setTextFormat(format);
		}
	}
}